/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/exception.hh>
#include <uds/init.hh>
#include <uds/io_util.hh>
#include <uds/streamsocket.hh>
#include <uds/uds.hh>
#include <iostream>
#include <unistd.h>

using namespace std;
using namespace uds;


const unsigned short port = 1985;

void
server()
{
	TCPSocket sock;
	sock.Listen( port );
	cout<<"listening on port "<<port<<endl;

	TCPSocket conn( sock.Accept() );
	cout<<"accepted connection\n";

	sleep( 1 );

	string data = ReadLine( conn );
	cout<<"received message `"<<data<<"'\n";
}

void
client()
{
	sleep( 1 );

	cout<<"connecting to port "<<port<<endl;
	TCPSocket sock;
	sock.Connect( "localhost", port );
	sock<<"guru meditation\n"<<flush;
}

int
main()
{
	uds::Init uds_init;

	try
	{
		if ( fork() )
			server();
		else
			client();
	}
	catch ( Exception& e )
	{
		cerr<<e.Message();
	}

	return 0;
}
