/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/filestream.hh>
#include <uds/init.hh>
#include <uds/exception.hh>

using namespace std;
using namespace uds;


int
main()
{
	uds::Init uds_init;

	try
	{
		FileStream fs( "testfile", ios::in | ios::out | ios::trunc );
		
		cout<<"write 11 chars\n";
		fs<<"1234567890\n";
		cout<<"tellg: "<<fs.tellg()<<endl
			<<"tellp: "<<fs.tellp()<<endl
			<<endl;

		cout<<"seekg( 3 )\n";
		fs.seekg( 3 );
		cout<<"tellg: "<<fs.tellg()<<endl
			<<"tellp: "<<fs.tellp()<<endl
			<<endl;

		cout<<"read 3 chars\n";
		char buf[4] = { 0 };
		fs.read( buf, 3 );
		cout<<buf<<endl
			<<"tellg: "<<fs.tellg()<<endl
			<<"tellp: "<<fs.tellp()<<endl
			<<endl;
	}
	catch ( uds::Exception& e )
	{
		cerr<<e.Message();
	}

	return 0;
}
