/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/init.hh>
#include <uds/log.hh>
#include <iostream>

using namespace std;
using namespace uds;


int
main()
{
	uds::Init uds_init;

	// log all messages with LOG_NOTICE priority or higher to to syslog,
	// and all messages with LOG_INFO priority or higher to the logfile
	Logger log( LOG_NOTICE + 1, LOG_INFO + 1 );
	log.OpenLog( "UDS-Test", "logfile", LOG_PID | LOG_CONS, LOG_USER,
				 Logger::use_ident | Logger::log_pid | Logger::print_pri
				 | Logger::print_time );

	cout<<"sending log message with LOG_NOTICE priority\n";
	log( LOG_NOTICE, "UDS log-test (priority: LOG_NOTICE)" );

	cout<<"sending log message with LOG_INFO priority\n";
	log( LOG_INFO, "UDS log-test (priority: LOG_INFO)" );

	return 0;
}
