/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/init.hh>
#include <uds/str_util.hh>
#include <iostream>

using namespace std;
using namespace uds;


int
main( int argc, const char** argv )
{
	uds::Init uds_init;

	if ( argc != 2 )
	{
		cerr<<"usage:  "<<argv[0]<<" <int>\n";
		return 1;
	}

	try
	{
		int v = VarConv< int >( argv[1] );
		cout<<"value: "<<StringVar( v )<<endl;
	}
	catch ( runtime_error& )
	{
		cout<<"not a valid int\n";
	}

	return 0;
}
