/*
 * UDS Example Program
 * Copyright (C) 2000, 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/functional.hh>
#include <uds/init.hh>
#include <uds/uds.hh>
#include <uds/stl_ext.hh>
#include <algorithm>
#include <iostream>
#include <map>

using namespace std;
using uds::Delete;


// configure UDS
uds::uds_flags_t uds::flags = uds::log_allocs;


int
main()
{
	uds::Init uds_init;
	
	typedef map< int, int* > Map;
	Map m;
	m[3] = new int();
	m[6] = new int();
	
	cout<<"deleting all map values...\n";
	
	for_each( m.begin(), m.end(),
		uds::function( Delete< int >,
		uds::select2nd< Map::value_type >() ));
	
	return 0;
}
