/*
 * UDS Example Program
 * Copyright (C) 2000, 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/init.hh>
#include <uds/refcounter.hh>
#include <iostream>

using namespace std;


// class that uses reference counting

class RefC : public uds::RefCounter<>
{
public:
	RefC() { cout<<"constructor\n"; }
	RefC( const RefC& ) { cout<<"copy constructor\n"; }
	~RefC() { cout<<"destructor\n"; }
	
	void
	func() const {}
};

typedef uds::CoW_Ptr< RefC > CoW_Obj;


CoW_Obj
new_object()
{
	return new RefC();
}

int
main()
{
	uds::Init uds_init;
	
	CoW_Obj x = new_object();
	const CoW_Obj y = x;
	
	cout<<"calling member function through constant smart pointer\n";
	y->func();
	
	cout<<"calling member function through non-constant smart pointer\n";
	x->func();
	
	return 0;
}
