/*
 * The UDS Collection
 * Copyright (C) 2000, 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/functional.hh>
#include <uds/init.hh>
#include <uds/thread.hh>
#include <iostream>
#include <unistd.h>

using namespace std;
using namespace uds;


void*
thread_start()
{
	cout<<"new thread started\n";
	sleep( 1 );
	cout<<"leaving new thread\n";
	
	return 0;
}

void
cleanup( int a, double b )
{
	cout<<"cleanup "<<a<<" / "<<b<<endl;
}

int
main()
{
	uds::Init uds_init;
	
	Thread& t = *new Thread( &thread_start );
	t.PushCleanupHandler( function( &cleanup, value( 4 ), value( 3.68 ) ));
	sleep( 2 );
	cout<<"leaving main thread\n";
	
	return 0;
}
