/*
 * The UDS Collection
 * Copyright (C) 2000, 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/action.hh>
#include <uds/functional.hh>
#include <uds/init.hh>
#include <iostream>

using namespace std;
using namespace uds;


int
main()
{
	uds::Init uds_init;
	
	typedef ostream& ( * op_t )( ostream&, const char* );
	
	// the cast is necessary since ostream::operator << is overloaded,
	// makes things look more complicated than they are...
	AnyAction act( function( static_cast< op_t >( &operator << ),
		reference( cout ), value( "hello world!\n" ) ));
	
	act();
	
	return 0;
}
