/*
 * The UDS Collection
 * Copyright (C) 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/idep.hh>
#include <uds/procstream.hh>
#include <uds/str_util.hh>
#include <uds/sys_util.hh>
#include <unistd.h>
#include "config.h"


namespace uds
{

// misc. implementation

void
Addr2LinePS( ProcStream& ps, bool bn )
{
	string exe = "/proc/" + StringVar( getpid() ) + "/exe";
	
	if ( strlen( ADDRTOLINE )
		 && FileAccess( ADDRTOLINE, R_OK | X_OK )
		 && FileAccess( exe.c_str(), R_OK ) )
	{
		string cmd = ADDRTOLINE " -Cf";
		if ( bn )
			cmd += "s";
		cmd += "e " + exe;

		ps.Open( cmd, true, SIGKILL );
	}
	else
		ps.Close();
}

}
