/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/init.hh>
#include <uds/sentinel.hh>
#include <uds/stdexcpt.hh>
#include <uds/uds.hh>


namespace uds
{

namespace
{

int	refc = 0;

}

// Init implementation

Init::Init()
{
	++refc;
}

Init::~Init()
{
	if ( refc-- == 0 )
		_uds_abort;

	if ( refc == 0 && flags & leak_check )
		sentinel().Check();
}


// misc. implementation

bool
Initialized()
{
	return refc;
}

}
