/*
 * The UDS Collection
 * Copyright (C) 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/str_util.hh>


namespace uds
{

// misc. implementation

string
TrString( const string& s, size_t n, const string& e )
{
	if ( s.size() <= n )
		return s;

	return s.substr( 0, n ) + e;
}

string
BreakLine( const string& l, size_t w, size_t m, size_t f )
{
	stringstream ret;
	size_t len = m - w;

	if ( f == 0 )
		f = m - w;

	for ( size_t offs = 0; offs < l.size(); )
	{
		size_t cl = offs ? len : f;
		
		if ( offs && w )
			ret<<string( w, ' ' );

		ret<<l.substr( offs, cl )<<endl;
		offs += cl;
	}

	return ret.str();
}

string
ShellQuote( const string& str )
{
	string r = str;

	for ( size_t i = 0; i < r.size(); ++i )
		if ( r[i] == '$' || r[i] == '`' || r[i] == '"' || r[i] == '\\'
			 || r[i] == '\n' )
			r.insert( i++, "\\" );

	r.insert( 0, "\"" );
	r += "\"";

	return r;
}

}
