/*
 * The UDS Collection
 * Copyright (C) 2000, 2001, 2002, 2003  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <uds/io_util.hh>
#include <uds/str_util.hh>
#include <uds/uds.hh>
#include <sstream>
#include "config.h"


namespace uds
{

uds_flags_t flags = 0;


Version_t
Version()
{
	static Version_t version( VERSION );
	return version;
}


// Version_t implementation

Version_t::Version_t( const char* v )
{
	istringstream ss( v );

	unsigned vmaj = VarConv< unsigned >( ReadLine( ss, false, true, '.' ) );
	unsigned vmin = VarConv< unsigned >( ReadLine( ss, false, true, '.' ) );
	unsigned vpat = VarConv< unsigned >( ReadLine( ss ) );

	init( vmaj, vmin, vpat );
}

Version_t::Version_t( unsigned vmaj, unsigned vmin, unsigned vpat )
{
	init( vmaj, vmin, vpat );
}

void
Version_t::init( unsigned vmaj, unsigned vmin, unsigned vpat )
{
	ver = ( vmaj & 0xff ) << 24
		| ( vmin & 0xff ) << 16
		| vpat & 0xffff;
}

}
